/*
 * Project:        Exercise 7.1b
 * File:           exercise_7_1b.C
 * Author:         Benno List
 * Version (date): 1.0 (23.06.2013)
 *
 * Copyright (C) 2013, Benno List
 * All rights reserved.
 *
 * Description:
 * A ROOT macro for interactive ROOT sessions. See the READE file for
 * more details.
 *
 * This code is distributed with the solution manual to the book
 *
 * Data Analysis in High Energy Physics: A Practical Guide to Statistical Methods,
 * Wiley-VCH (2013),
 * O. Behnke, K. Kroeninger, G. Schott, Th. Schorrner-Sadenius (editors)
 */

int newtonit (int nit, double& e1, double& e2, double& l, 
              double e1m, double e2m, double s1, double s2, double r, double psi, double m) {
  double rfact = 1./(1-r*r);
  double pfact = 1-cos(psi);
  int n = 0;
  while (n++ < nit) {
    TVectorD vec(3);
    vec(0) =  -2*(e1-e1m)*rfact/(s1*s1) + 2*r*(e2-e2m)*rfact/(s1*s2) - 2*l*e2*pfact;
    vec(1) =  -2*(e2-e2m)*rfact/(s2*s2) + 2*r*(e1-e1m)*rfact/(s1*s2) - 2*l*e1*pfact;
    vec(2) =                                                         - 2*e1*e2*pfact + m*m;
    TMatrixDSym mat(3);
    mat(0,0) =            2*rfact/(s1*s1);
    mat(0,1) = mat(1,0) = -2*r*rfact/(s1*s2) + 2*l*pfact;
    mat(1,1) =            2*rfact/(s2*s2);
    mat(0,2) = mat(2,0) = 2*e2*pfact;
    mat(1,2) = mat(2,1) = 2*e1*pfact;
    mat(2,2) =            0;
    bool ok;
    TDecompLU lu(3);
    lu.SetMatrix(mat);
    ok = lu.Decompose();
    if (!ok) return 2;
    ok = lu.Solve(vec);
    if (!ok) return 1;
    e1 += vec[0];
    e2 += vec[1];
    l  += vec[2];
  }
  return 0;
}

