/*
 * Project:        Exercise 7.1c
 * File:           exercise_7_1c.C
 * Author:         Benno List
 * Version (date): 1.0 (23.06.2013)
 *
 * Copyright (C) 2013, Benno List
 * All rights reserved.
 *
 * Description:
 * A ROOT macro for interactive ROOT sessions. See the READE file for
 * more details.
 *
 * This code is distributed with the solution manual to the book
 *
 * Data Analysis in High Energy Physics: A Practical Guide to Statistical Methods,
 * Wiley-VCH (2013),
 * O. Behnke, K. Kroeninger, G. Schott, Th. Schorrner-Sadenius (editors)
 */

TH2F *plotimprovement (int nit, 
                       double nx=160, double xl=0, double xr=16, 
                       double ny=100, double yb=2, double yt=12) {
  stringstream title;
  title << "Log_{10} (Distance Ratio) for " << nit << " Iterations;E_{1};E_{2}";
  TH2F *h = new TH2F ("improvement", title.str().c_str(), nx, xl, xr, ny, yb, yt);
  for (int i = 1; i <= h->GetNbinsX(); ++i) {
    for (int j = 1; j <= h->GetNbinsY(); ++j) {
      double e1 = h->GetXaxis()->GetBinCenter (i);
      double e2 = h->GetYaxis()->GetBinCenter (j);
      double d0 = sqrt(pow (e1-6.14827646488922230, 2)+pow (e2-4.06618019582670698, 2));
      double l = 0;
      newtonit (nit, e1, e2, l, 6, 7, 1, 1.5, -0.5, 1.570796326794897, sqrt(50.0));
      double d1 = sqrt(pow (e1-6.14828, 2)+pow (e2-4.06618, 2));
      h->SetBinContent (i, j, log10(d1/d0));
    }
  }
  return h;
}
